package openngvfs

import (
	"fmt"
	"github.com/BurntSushi/toml"
	"os"
)

type RawFsTab struct {
	Wasm struct {
		Default string            `toml:"default"`
		App     map[string]string `toml:"app"`
	} `toml:"wasm"`
	ExKV struct {
		Default map[string]string            `toml:"default"`
		App     map[string]map[string]string `toml:"app"`
	} `toml:"exkv"`
}

func loadFsTab(path string) (*RawFsTab, error) {
	var fstab RawFsTab
	ftBin, err := os.ReadFile(path)
	if err != nil {
		return nil, fmt.Errorf("failed read fstab.toml: %w", err)
	}
	err = toml.Unmarshal(ftBin, &fstab)
	if err != nil {
		return nil, fmt.Errorf("failed parse fstab.toml: %w", err)
	}
	return &fstab, nil
}

type ProcessedFsTab struct {
	ExKV map[string]string
}
